#include <bits/stdc++.h>
using namespace std;
#define rep(i,a,b) for (auto i=(a); i<(b); ++i)
#define iter(it,c) for (auto it = (c).begin(); it != (c).end(); ++it)
typedef pair<long, long> ii;
typedef vector<long> vi;
typedef vector<ii> vii;
typedef vector<vi> vvi;
typedef long long ll;
const long INF = 100000000000000;

#define MAXV 2000
long q[MAXV], d[MAXV];
struct flow_network {
  struct edge { long v, nxt, cap;
    edge(long _v, long _cap, long _nxt)
      : v(_v), nxt(_nxt), cap(_cap) { } };
  long n, *head, *curh; vector<edge> e, e_store;
  flow_network(long _n) : n(_n) {
    curh = new long[n];
    memset(head = new long[n], -1, n*sizeof(long)); }
  void reset() { e = e_store; }
  void add_edge(long u, long v, long uv, long vu=0) {
    e.push_back(edge(v,uv,head[u])); head[u]=(long)e.size()-1;
    e.push_back(edge(u,vu,head[v])); head[v]=(long)e.size()-1;}
  long augment(long v, long t, long f) {
    if (v == t) return f;
    for (long &i = curh[v], ret; i != -1; i = e[i].nxt)
      if (e[i].cap > 0 && d[e[i].v] + 1 == d[v])
        if ((ret = augment(e[i].v, t, min(f, e[i].cap))) > 0)
          return (e[i].cap -= ret, e[i^1].cap += ret, ret);
    return 0; }
  long max_flow(long s, long t, bool res=true) {
    e_store = e;
    long l, r, f = 0, x;
    while (true) {
      memset(d, -1, n*sizeof(long));
      l = r = 0, d[q[r++] = t] = 0;
      while (l < r)
        for (long v = q[l++], i = head[v]; i != -1; i=e[i].nxt)
          if (e[i^1].cap > 0 && d[e[i].v] == -1)
            d[q[r++] = e[i].v] = d[v]+1;
      if (d[s] == -1) break;
      memcpy(curh, head, n * sizeof(long));
      while ((x = augment(s, t, INF)) != 0) f += x; }
    if (res) reset();
    return f; } };

int main() {
    long n;
    cin >> n;

    long SOURCE = 0,
        SINK = 1,
        V = 2,
        CNT = V+n;

    flow_network G(CNT);

    long sm = 0;
    rep(i,0,n) {
        long cost, cnt;
        cin >> cost >> cnt;
        rep(j,0,cnt) {
            long dep;
            cin >> dep;
            dep--;
            G.add_edge(V+dep, V+i, INF);
        }

        if (cost < 0) {
            G.add_edge(SOURCE, V+i, -cost);
        }
        if (cost > 0) {
            sm += cost;
            G.add_edge(V+i, SINK, cost);
        }
    }

    cout << sm - G.max_flow(SOURCE, SINK) << endl;
    rep(i,0,n) {
      if (d[V+i] != -1) {
        cout << i+1 << " ";
      }
    }

    return 0;
}

