#include <bits/stdc++.h>
using namespace std; 

long n;
vector<vector<long> > graph;

vector<bool> visited;
long bfs_flow(long s, long t, vector<long> &parent) {
    visited.assign(n+2,false);
    queue<pair<long, long>> q;

    q.push({s,INT_MAX});
    visited[s] = true;
    parent[s] = -1;

    while (!q.empty()) {
        long u = q.front().first;
        long flow = q.front().second;
        q.pop();

        for (long v = 0; v < n+2; v++) {
            if (visited[v]==false && graph[u][v] > 0) {
                long new_flow = min(flow, graph[u][v]);
                parent[v] = u;
                visited[v] = true;
                if (v == t)
                    return new_flow;
                q.push({v,new_flow});
            }
        }
    }

    return 0;
}

long long max_flow(long s, long t) {
    long u, v;
    vector<long> parent(n+2);
  
    long long res = 0;
    long path_flow = 0;

    while ((path_flow = bfs_flow(s, t, parent)) > 0) {
        for (v = t; v != s; v = parent[v]) {
            u = parent[v];
            graph[u][v] -= path_flow;
            graph[v][u] += path_flow;
        }

        res += path_flow;
    }

    return res;
}

int main() {
    cin >> n;

    graph.resize(n+2, vector<long>(n+2));

    long long res = 0;

    for (long i = 1; i <= n; i++) {
        long weight;
        long degree;

        cin >> weight >> degree;

        if (weight >= 0) {
            res += weight;
            graph[0][i] = weight;
        } else {
            graph[i][n+1] = -weight;
        }

        for (long j = 0; j < degree; j++) {
            long v;
            cin >> v;

            graph[i][v] = INT_MAX;
        }
    }

    cout << res - max_flow(0, n+1) << endl; 
    for (long i = 1; i <= n; i++) {
      if (visited[i]) {
        cout << i << " ";
      }
    }
    cout<<endl;

    return 0; 
}
