#include <bits/stdc++.h>
using namespace std;

const long INF = LONG_MAX/2;

struct flow_network {
	struct edge { long to, cap; };
	
	long n, s, t;
	vector<bool> mark;
	vector<vector<long>> adj;
	vector<edge> e;

	flow_network(long n, long s, long t): n(n), s(s), t(t), adj(n) { }

	void add_edge(long a, long b, long c) {
		adj[a].push_back(e.size());
		e.push_back({b,c});
		adj[b].push_back(e.size());
		e.push_back({a,0});
	}
	
	long dfs(long i, long cap, long delta) {
		if (i == t) return cap;
		if (mark[i]) return 0;
		mark[i] = true;
		for (long j: adj[i]) if (e[j].cap >= delta) {
			if (long c = dfs(e[j].to, min(cap,e[j].cap), delta)) {
				e[j].cap -= c, e[j^1].cap += c;
				return c;
			}
		}
		return 0;
	}

	pair<long, vector<bool>> max_flow() {
		long flow = 0, delta = INF;
		while (delta > 0) {
			mark.assign(n,false);
			long c = dfs(s,INF,delta);
			if (c) flow += c; else delta /= 2;
		}
		return {flow, mark};
	}
};

int main() {
	long n; cin >> n;
	flow_network F(n+2,n,n+1);

	long res = 0;
	for (long i = 0; i < n; i++) {
		long w, m;
		cin >> w >> m;
		res += max(w,0l);
		if (w > 0) F.add_edge(n,i,w);
		else F.add_edge(i,n+1,-w);
		
		while (m--) {
			long j; cin >> j;
			F.add_edge(i,j-1,INF);
		}
	}
  auto [flow, mark] = F.max_flow();
	res -= flow;
	cout << res << endl;
  for (int i = 0 ; i < n; i++) {
    if (mark[i]) {
      cout << i+1 << " ";
    }
  }
  cout << endl;
}
