import java.io.*;
import java.util.*;

public class rgl {
  private static class flowgraph {
    private static class edge {
      final int to;
      edge rev;
      long cap;

      public edge(int to, long cap) {
        this.to = to;
        this.cap = cap;
      }
    }

    final int n;
    final int[] d;
    final List<edge>[] e;

    public flowgraph(int n) {
      this.n = n;
      this.d = new int[n+2];
      this.e = (List<edge>[]) new List[n+2];
      for (int i = 0; i < n+2; i++) {
        this.e[i] = new ArrayList<>();
      }
    }

    public void addEdge(int a, int b, long c) {
      edge ea = new edge(b, c); this.e[a].add(ea);
      edge eb = new edge(a, 0); this.e[b].add(eb);
      ea.rev = eb;
      eb.rev = ea;
    }

    public boolean bfs() {
      Arrays.fill(d, -1);
      d[n] = 0;
      ArrayDeque<Integer> todo = new ArrayDeque<>(n+2);
      for (todo.offer(n); !todo.isEmpty();) {
        int x = todo.remove();
        for (edge ed : e[x]) {
          if (ed.cap > 0 && d[ed.to] == -1) {
            d[ed.to] = d[x] + 1;
            todo.offer(ed.to);
          }
        }
      }
      return d[n+1] != -1;
    }

    long dfs(int x, long m) {
      if (x == n+1 || m == 0) {
        return m;
      }
      long res = 0;
      for (edge ed : e[x]) {
        if (d[ed.to] == d[x]+1) {
          long k = dfs(ed.to, Math.min(m-res, ed.cap));
          res += k;
          ed.cap -= k;
          ed.rev.cap += k;
        }
      }
      if (res == 0) {
        d[x] = -1;
      }
      return res;
    }
  }

  public static void main(String[] args) {
    final Scanner scan = new Scanner(System.in);
    final int n = scan.nextInt();

    final int[] h = new int[n];
    flowgraph g = new flowgraph(n);
    for (int i = 0; i < n; i++) {
      h[i] = scan.nextInt();
      if (h[i] > 0) {
        g.addEdge(n, i, h[i]);
      } else {
        g.addEdge(i, n+1, -h[i]);
      }
      for (int m = scan.nextInt(); m > 0; m--) {
        g.addEdge(i, scan.nextInt()-1, 1L << 40L);
      }
    }

    while (g.bfs()) {
      g.dfs(n, 1L << 40L);
    }
    long res = 0 ;
    for (int i = 0; i < n; i++) {
      if (g.d[i] != -1) {
        res += h[i];
      }
    }
    System.out.println(res);
    for (int i = 0; i < n; i++) {
      if (g.d[i] != -1) {
        System.out.print(" " + (i+1));
      }
    }
    System.out.println();
  }
}
