#include <bits/stdc++.h>
using namespace std;

enum color { white, grey, black };

int n;
vector<list<int> > edges;
vector<int> nodes, weights;

int dfs_visit(int v, vector<color> &colors) {
    // cycles in the input?
    colors[v] = grey;
    list<int> new_edges;
    for (int u : edges[v]) {
        if (colors[u] == white) {
            dfs_visit(u, colors);
        }

        for (int w : edges[u]) {
            new_edges.push_back(w);
        }
    }
    
    edges[v].merge(new_edges);
    
    colors[v] = black;
    nodes.insert(nodes.begin(), v);
    return 0;
}

pair<int, vector<bool>> max_weight(int i, vector<bool> in) {
    if (i < 0) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            if (in[j])
                sum += weights[j];
        }
        return {sum, in};
    }

    pair<int, vector<bool>> w1, w2;

    // YES
    if (in[nodes[i]]) {
      w1 = max_weight(i-1, in);
    }
    
    // NO
    in[nodes[i]] = false;
    for (int w : edges[nodes[i]])
        in[w] = false;

    w2 = max_weight(i-1, in);

    return ((w1.first > w2.first) ? w1 : w2);
}

int main() {
    cin >> n;

    edges.resize(n);
    weights.resize(n);

    for (int i = 0; i < n; i++) {
        int weight, degree;

        cin >> weight >> degree;

        weights[i] = weight;
        for (int j = 0; j < degree; j++) {
            int v;
            cin >> v;
            edges[v-1].push_back(i);
        }
    }
    
    // DFS
    vector<color> colors(n, white);

    for (int v = 0; v < n; v++) {
        if (colors[v] == white)
            dfs_visit(v, colors);
    }
    
    vector<bool> in(n, true);

    auto [score, used] = max_weight(n-1, in);
    cout << score << endl;
    for (int i = 0; i < n; i++) {
      if (used[i]) {
        cout << " " << i+1;
      }
    }
    cout << endl;

    return 0;
}

